{Program oblicza wspolczynniki wielomianu oraz wartosc w(x)}

program wspol_wielomianu;
uses crt;


type tab=array[0..100] of real;

procedure obliczB(var b:tab; x,y:tab; n:integer);
{Oblicza wspolczynniki wielomianu na podstawie danych dwoch tablic. Kolejno
 x:tab=>zawierajaca x, y:tab=>zawierajaca y. Nastepnie wylicza trzecia
 tablice b:tab=>zawierajaca obliczone wspolczynniki wielomianu}

var i,j:integer;
    k:real;
begin
{Mamy do czynienia z tablica dwuwymiarowa x i y. Z tego powodu
 zastosowalem petle(for) w petli(for). Dlatego wygodniej jest obliczac
 wspolczynniki od dolu, gdyz stosujac wzor na obliczenie odpowiedniej roznicy
 od razu podstawiam wartosc pod danego y w tablicy y:tab.}

   for i:=1 to n do
   begin
      for j:=n downto i do
      begin
         k:=(y[j]-y[j-1])/(x[j]-x[j-i]);
         y[j]:=k;
      end;
   end;

{Powyzej pracowalem na x i y. Wiec zamieniam obliczone wartosci y na b czyli
 na tablice wspolczynnikow wielomianu}
b:=y;
end;

function wart(p:real; n:integer; b:tab; x:tab):real;
{Oblicza wartosc wielomianu w dla danej wartosci p. Przy obliczeniach
 korzysta z uproszczonego algorytmu Hornera}

var w:real;
    i:integer;
begin
   w:=b[n];
   for i:=n-1 downto 0 do
   begin
      w:=w*(p-x[i]) + b[i];
   end;
wart:=w;
end;



var
n,i:integer;
x,y,b:tab;
p:real;

{Program glowny}

begin

   {Ponizej znajduja sie przykladowe tablice x i y oraz zalozone n i p dla
    ktorych program ma wykonac obliczenia}

   clrscr;
   n:=4;
   p:=4.2;
   x[0]:=0;
   x[1]:=1;
   x[2]:=2;
   x[3]:=4;
   x[4]:=6;

   y[0]:=1;
   y[1]:=9;
   y[2]:=23;
   y[3]:=93;
   y[4]:=259;

   obliczB(b,x,y,n);
   writeln('Wspolczynniki wielomianu wynosza (kolejnosc to b0, b1, b2...): ');
   for i:=0 to n do
   writeln(b[i]:1:2);
   writeln('');
   writeln('Wartosc wielomianu w od argumentu rzeczywistego x rownego '
           ,p:1:2,' wynosi: ');
   writeln('w= ',wart(p,n,b,x):1:6);
   repeat until keypressed;
end.